'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (_ref) {
    var types = _ref.types;

    var plugins = null;

    function applyInstance(method, args, context) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = plugins[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var plugin = _step.value;

                if (plugin[method]) {
                    plugin[method].apply(plugin, [].concat(_toConsumableArray(args), [context]));
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }

    function Program(path, _ref2) {
        var _ref2$opts = _ref2.opts,
            opts = _ref2$opts === undefined ? {} : _ref2$opts;

        // Init plugin instances once.
        if (!plugins) {
            if (Array.isArray(opts)) {
                plugins = opts.map(function (_ref3) {
                    var libraryName = _ref3.libraryName,
                        libraryDirectory = _ref3.libraryDirectory,
                        style = _ref3.style,
                        camel2DashComponentName = _ref3.camel2DashComponentName,
                        camel2UnderlineComponentName = _ref3.camel2UnderlineComponentName,
                        priLib = _ref3.priLib;

                    return new Plugin(libraryName, libraryDirectory, style, camel2DashComponentName, camel2UnderlineComponentName, types, priLib);
                });
            } else {
                plugins = [new Plugin(opts.libraryName, opts.libraryDirectory, opts.style, opts.camel2DashComponentName, opts.camel2UnderlineComponentName, opts.priLib, types)];
            }
        }
        applyInstance('Program', arguments, this); // eslint-disable-line
    }

    var methods = ['ImportDeclaration', 'CallExpression', 'MemberExpression', 'Property', 'VariableDeclarator', 'LogicalExpression', 'ConditionalExpression', 'IfStatement', 'ExpressionStatement', 'ReturnStatement', 'ExportDefaultDeclaration'];

    var ret = {
        visitor: { Program: Program }
    };

    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
        var _loop = function _loop() {
            var method = _step2.value;

            ret.visitor[method] = function () {
                // eslint-disable-line
                applyInstance(method, arguments, ret.visitor); // eslint-disable-line
            };
        };

        for (var _iterator2 = methods[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            _loop();
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
            }
        } finally {
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }

    return ret;
};

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var pluginImport = require('babel-plugin-import/lib/Plugin.js');

var Plugin = function (_pluginImport) {
    _inherits(Plugin, _pluginImport);

    function Plugin(props) {
        _classCallCheck(this, Plugin);

        var _this = _possibleConstructorReturn(this, (Plugin.__proto__ || Object.getPrototypeOf(Plugin)).call(this, props));

        _this.preLib = props.preLib || '';
        return _this;
    }

    _createClass(Plugin, [{
        key: 'importMethod',
        value: function importMethod(methodName, file) {
            if (!this.selectedMethods[methodName]) {
                var libraryDirectory = this.libraryDirectory;
                var style = this.style;
                var transformedMethodName = this.camel2UnderlineComponentName // eslint-disable-line
                ? camel2Underline(methodName) : this.camel2DashComponentName ? camel2Dash(methodName) : methodName;
                var path = winPath(join(this.preLib, this.libraryName, libraryDirectory, transformedMethodName));
                this.selectedMethods[methodName] = file.addImport(path, 'default');
                if (style === true) {
                    file.addImport(path + '/style', 'style');
                } else if (style === 'css') {
                    file.addImport(path + '/style/css', 'style');
                }
            }
            return this.selectedMethods[methodName];
        }
    }]);

    return Plugin;
}(pluginImport);

module.exports = exports['default'];